// Types.h

// Material structure (corresponds with Material defined in glsl files)
struct Material {
    GLfloat diffuseColor[4];
    GLfloat specularColor[4];
    GLuint64 diffuseTexture;
    GLuint64 specularTexture;
    GLuint64 normalTexture;
    GLuint64 padding;
};

// Light structure (corresponds with Light defined in glsl files)
struct Light {
    GLfloat eyePosition[3];
    GLfloat eyePositionPadding;
    GLfloat diffuse[3];
    GLfloat diffusePadding;
    GLfloat specular[3];
    GLfloat specularPadding;
};