// BindlessBuffer.h

#pragma once

// BindlessBuffer
class BindlessBuffer
{
public:
    // Constructor and destructor
    BindlessBuffer();
    ~BindlessBuffer();

    // Accessors
    GLuint Buffer() const;
    GLuint64EXT GpuAddress() const;
    GLsizeiptr Size() const;

    // Create
    bool Create(GLsizeiptr size, const GLvoid* data, GLenum usage);
    bool CreateAndMakeResident(GLsizeiptr size, const GLvoid* data, GLenum usage, GLenum access);

    // Residency
    void MakeResident(GLenum access) const;
    void MakeNonResident() const;

    // IsSupported
    static bool IsSupported();
    
private:
    void Destroy();

    GLuint m_buffer;
    GLuint64EXT m_gpuAddress;
    GLsizeiptr m_size;
};