// GLBindlessTexture.h

#pragma once

// BindlessTexture
class BindlessTexture
{
public:
    // Constructor and destructor
    BindlessTexture();
    ~BindlessTexture();

    // Accessors
    GLuint Texture() const;
    GLuint64EXT Handle() const;
    GLenum Target() const;

    // Create
    bool Create2D(GLenum target, GLuint levels, GLenum format, GLuint width, GLuint height);
    bool Create2DAndMakeResident(GLenum target, GLuint levels, GLenum format, GLuint width, GLuint height);

    // Update
    void SubImage2D(GLenum target, GLuint level, GLuint xoffset, GLuint yoffset, GLuint width, GLuint height, GLenum format, GLenum type, GLvoid* data);
    void GenerateMipmap();

    // Residency
    void MakeResident() const;
    void MakeNonResident() const;

    // IsSupported
    static bool IsSupported();

private:
    void Destroy();

    GLuint m_texture;
    GLuint64EXT m_handle;
    GLenum m_target;
};