// GlslProgram.h

#pragma once

class GlslProgram
{
public:
    // Create a program from vs and fs source
    static GLuint CreateProgram(const GLchar* vsSource[], GLuint vsSourceLines, const GLchar* fsSource[], GLuint fsSourceLines);

    // Create a program from vs and fs files
    static GLuint CreateProgramFromFiles(const char* vsFilename, const char* fsFilename);

private:
    // Do common create program work using vs and fs shaders
    static GLuint CreateProgramCommon(GLuint vs, GLuint fs);

    // Create a shader of a given type from source
    static GLuint CreateShader(GLenum type, const GLchar* source[], GLuint sourceLines);

    // Create a shader of a given type from a file
    static GLuint CreateShaderFromFile(GLenum type, const char* filename);
};